// Moo2 Save Game Editor.cpp : Defines the entry point for the application.
//

#include "stdafx.h"

#include "resource.h"

#include <tchar.h>

#include <string>

#include <sstream>

#include <algorithm>

#include <windows.h>

#include <iostream>

#include <fstream>

#include <stdio.h>

#include <time.h>

#include <WindowsX.h>

#include "Defines.h"

#include "BringUp.cpp"

#include "SaveSessions.cpp"

#include "Utilities.cpp"

#include "DefineFunctions.cpp"

#include "Scroll.cpp"

#include "Dialog.cpp"

#include "BrowseForFile.cpp"

#include "Settings.cpp"

#include "Load.cpp"

#include "Alter.cpp"

using namespace std;

int APIENTRY _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine,int nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

	MSG msg;
	HACCEL hAccelTable;

	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_MOO2SAVEGAMEEDITOR, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_MOO2SAVEGAMEEDITOR));

	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}

ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_MOO2SAVEGAMEEDITOR));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_MOO2SAVEGAMEEDITOR);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; 

   hWnd = CreateWindow(szWindowClass, szTitle, WS_CAPTION | WS_THICKFRAME,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   LoadWindowRect(0, "Main",hWnd);
   
   UpdateWindow(hWnd);

   return TRUE;
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
   HDC hDC, MemDCMainWindow;
   PAINTSTRUCT Ps;
   HBITMAP bmpMainWindow;
   static int cxClient, cyClient;

	switch (message)
	{

   case WM_SIZE: 
      cxClient = LOWORD(lParam); 
      cyClient = HIWORD(lParam); 
      break;

	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);

		switch (wmId)
		{
		case IDM_ABOUT:
			ShowWindow(hAbout, SW_SHOW);
         LoadWindowRect(0, "About",hAbout);
			break;
      case IDM_SETTINGS:
			ShowWindow(hSettings, SW_SHOW);
         LoadWindowRect(0, "Settings",hSettings);
			break;
      case IDM_GALAXY_WIDE:
			ShowWindow(hGalaxy, SW_SHOW);
         LoadWindowRect(0, "Galaxy",hGalaxy);
			break;
      case IDM_QUIT:
         SaveWindowRect("Main",hWnd);
         if (Loaded == 1) {
            ShowWindow(hSaveQuit, SW_SHOW);
            LoadWindowRect(0, "SaveQuit", hSaveQuit);
         } else {
            PostQuitMessage(0);
            //exit(0);
         }
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		hDC = BeginPaint(hWnd, &Ps);
	   bmpMainWindow = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_MAIN_SCREEN));
	   MemDCMainWindow = CreateCompatibleDC(hDC);
      SelectObject(MemDCMainWindow, bmpMainWindow);
	   StretchBlt(hDC, 0, 0, cxClient + 10, cyClient + 10, MemDCMainWindow, 0, 0, 800, 600, SRCCOPY);
	   DeleteDC(MemDCMainWindow);
	   DeleteObject(bmpMainWindow);
		EndPaint(hWnd, &Ps);
		break;
	case WM_DESTROY:
      SaveWindowRect("Main",hWnd);
      if (Loaded == 1) {
         ShowWindow(hSaveQuit, SW_SHOW);
         LoadWindowRect(0, "SaveQuit", hSaveQuit);
      } else {
         PostQuitMessage(0);
         //exit(0);
      }
		break;
   case WM_CREATE:
      hExplain = CreateDialog(GetModuleHandle(NULL),MAKEINTRESOURCE(IDD_FOOD_EXPLAINATION),hWnd, FoodDescriptDialog); 
      ShowWindow(hExplain, SW_HIDE);
      hAbout = CreateDialog(GetModuleHandle(NULL),MAKEINTRESOURCE(IDD_ABOUTBOX),hWnd, AboutDialog); 
      ShowWindow(hAbout, SW_HIDE);
      hSettings = CreateDialog(GetModuleHandle(NULL),MAKEINTRESOURCE(IDD_SETTINGS_MENU),hWnd, SettingsDialog);
      ShowWindow(hSettings, SW_HIDE);
      hGalaxy = CreateDialog(GetModuleHandle(NULL),MAKEINTRESOURCE(IDD_GALAXY_WIDE),hWnd, GalaxyWideDialog);
      ShowWindow(hGalaxy, SW_HIDE);
      hFood = CreateDialog(GetModuleHandle(NULL),MAKEINTRESOURCE(IDD_FOOD),hWnd, FoodDialog);
      ShowWindow(hFood, SW_HIDE);
      hFood = CreateDialog(GetModuleHandle(NULL),MAKEINTRESOURCE(IDD_FOOD),hWnd, FoodDialog);
      ShowWindow(hFood, SW_HIDE);
      hSaveQuit = CreateDialog(GetModuleHandle(NULL),MAKEINTRESOURCE(IDD_SAVE_QUIT), hWnd, SaveQuitDialog);
      ShowWindow(hSaveQuit, SW_HIDE);
      hQuit = CreateDialog(GetModuleHandle(NULL),MAKEINTRESOURCE(IDD_QUIT), hWnd, QuitDialog);
      ShowWindow(hQuit, SW_HIDE);
      hRegistry = CreateDialog(GetModuleHandle(NULL),MAKEINTRESOURCE(IDD_REGISTRY), hWnd, RegistryDialog);
      ShowWindow(hRegistry, SW_HIDE);
      LoadSettings(hSettings);
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}




















